# TODO:
# - update to 21.6
# - executable should be sgid games?
Summary:	Superior chess program by Bob Hyatt for Unix systems
Summary(pl.UTF-8):	Jeden z lepszych programów szachowych dla uniksów autorstwa Boba Hyatta
Name:		crafty
Version:	23.4
Release:	1
License:	GPL
Group:		Applications/Games
Source0:	ftp://ftp.cis.uab.edu/pub/hyatt/source/%{name}-%{version}.zip
# Source0-md5:	7e0811dd2d801428d8da48a4e487885a
Source1:	ftp://ftp.cis.uab.edu/pub/hyatt/documentation/%{name}.doc.ascii
# NoSourceSource1-md5:	5fd73027a1de1674763562e1987197ba
Source2:	ftp://ftp.cis.uab.edu/pub/hyatt/documentation/%{name}.doc.ps
# Source2-md5:	6cef69aa2f9ea1ceb74b6c14edc8291f
Source3:	%{name}.desktop
Source4:	xchess.png
Source5:	%{name}-misc.tar.bz2
# Source5-md5:	28072241d4978a532ac3ef536b02557c
Source6:	%{name}-bitmaps.tar.gz
# Source6-md5:	e3e94a914f02dfe8b237b1de7376749e
Source7:	ftp://ftp.cis.uab.edu/pub/hyatt/book/book.bin
# Source7-md5:	6d527840579904bf0e0b0a456a580a9b
Patch0:		%{name}-paths.patch
Patch1:		%{name}-Makefile.patch
Patch2:		%{name}-security.patch
URL:		http://www.limunltd.com/crafty/
BuildRequires:	libstdc++-devel
BuildRequires:	sed >= 4.0
BuildRequires:	unzip
Provides:	chessprogram
Provides:	chess_backend
Suggests:	xboard
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		specflags	-fomit-frame-pointer

%description
Crafty is a Unix chess program, distributed as source by its author,
Bob Hyatt. The program plays at about 2200 strength and frequently
beats GNU Chess on the same hardware.

%description -l pl.UTF-8
Crafty to uniksowy program szachowy rozpowszechniany w postaci
źródłowej przez autora - Boba Hyatta. Program gra z siłą około 2200 i
często wygrywa z GNU Chess na tym samym sprzęcie.

%prep
%setup -q -a5 -a6
%patch0 -p0
%patch1 -p0
%patch2 -p0
mv doc/read.me README
mv doc/* .
mv bitmaps/README.bitmaps .
rm -f bitmaps/gifs.tar
cp %{SOURCE1} %{SOURCE2} .
cp %{SOURCE7} .

sed 's@.*machine/builtins.*@@' -i chess.h

%build
asmobj=""
optarch=""
target="LINUX"
%ifarch %{ix86}
optarch="-DUSE_ASSEMBLY_A -DUSE_ASSEMBLY_B"
asmobj="X86-elf.o"
%endif
%ifarch alpha
target="ALPHA"
%endif
%{__make} crafty-make \
	target="$target" \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags} -Wall -pipe -D_REENTRANT" \
	LDFLAGS="%{rpmldflags} -lpthread" \
	opt="-DCOMPACT_ATTACKS -DUSE_ATTACK_FUNCTIONS $optarch -DFAST" \
	asm="$asmobj"

sh make_books
#mv large_book.bin book.bin

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_mandir}/man6,%{_desktopdir},%{_pixmapsdir}} \
	$RPM_BUILD_ROOT{%{_datadir}/%{name}/{bitmaps,sound,tb},/var/lib/%{name}}

install crafty $RPM_BUILD_ROOT%{_bindir}
install xcrafty $RPM_BUILD_ROOT%{_bindir}
install speak $RPM_BUILD_ROOT%{_bindir}/crafty-speak

install book.bin books.bin crafty.hlp $RPM_BUILD_ROOT%{_datadir}/%{name}
install bitmaps/* $RPM_BUILD_ROOT%{_datadir}/%{name}/bitmaps
install tb/*.emd $RPM_BUILD_ROOT%{_datadir}/%{name}/tb

install crafty.6 $RPM_BUILD_ROOT%{_mandir}/man6
echo ".so crafty.6" > $RPM_BUILD_ROOT%{_mandir}/man6/xcrafty.6

install %{SOURCE3} $RPM_BUILD_ROOT%{_desktopdir}
install %{SOURCE4} $RPM_BUILD_ROOT%{_pixmapsdir}

touch $RPM_BUILD_ROOT/var/lib/%{name}/book.lrn \
	$RPM_BUILD_ROOT/var/lib/%{name}/position.{bin,lrn}

for file in book.lrn position.{bin,lrn}; do
	ln -s /var/lib/%{name}/$file $RPM_BUILD_ROOT%{_datadir}/%{name}/$file
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc crafty.doc* crafty.faq README* small.txt start.pgn tournament.howto
%attr(755,root,root) %{_bindir}/crafty*
%attr(755,root,root) %{_bindir}/xcrafty
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.bin
%{_datadir}/%{name}/*.hlp
%{_datadir}/%{name}/*.lrn
%dir %{_datadir}/%{name}/bitmaps
%{_datadir}/%{name}/bitmaps/*.bm
%{_datadir}/%{name}/bitmaps/*.gif
%dir %{_datadir}/%{name}/tb
%{_datadir}/%{name}/tb/*.emd
%dir /var/lib/%{name}
%attr(660,root,games) %config(noreplace) %verify(not md5 mtime size) /var/lib/%{name}/book.lrn
%attr(660,root,games) %config(noreplace) %verify(not md5 mtime size) /var/lib/%{name}/position.bin
%attr(660,root,games) %config(noreplace) %verify(not md5 mtime size) /var/lib/%{name}/position.lrn
%{_mandir}/man6/*.6*
%{_desktopdir}/*.desktop
%{_pixmapsdir}/*
%changelog
* Mon May 07 2012 blekot <blekot@pld-linux.org> 66a4c5c
- add forgotten comment about this patch: crafty.bin locally exploitable to gain gid 'games'
- see: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=203541

* Mon May 07 2012 blekot <blekot@pld-linux.org> 2c9c374
- up to 23.4
- added security patch from debian
- removed MDK patch (not needed anymore)
- large book doesn't work with never versions of crafty
- added book.bin instead

* Mon May 07 2012 blekot <blekot@pld-linux.org> dcfe569
- removed (not needed for this version)

* Mon May 07 2012 blekot <blekot@pld-linux.org> c2d7e4a
- updated

* Mon May 07 2012 blekot <blekot@pld-linux.org> 34030ae
- new

* Fri Jun 17 2011 Kacper Kornet <draenog@pld-linux.org> c747f21
- remove binary sources to distfiles

* Fri Nov 27 2009 sparky <sparky@pld-linux.org> b46e92c
- use sed instead of perl (not part of minimal builder chroot)
- BR: sed >= 4.0, unzip

* Sun Jul 05 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 7d33f6e
- drop obsolete files

* Wed Dec 26 2007 blekot <blekot@pld-linux.org> 6b65878
- massive change ( validate errors warrings from desktop-file-validate)
  - sed -i 's,Encoding=UTF-8,,g' *.desktop
  - sed -i "s,.png,,1" `grep -l 'Icon=[^/].*\.png' *.desktop`
  - sed -i "s,MimeType=.*,\0;,g" `grep "MimeType.*semicolon" validate |awk '{print $1}' |tr ":" " "`
  - sed -i 's,MapNotify=.*,,g' *.desktop
  - sed -i '/^$/d' *.desktop
- not all error/warrings validated

* Sun Nov 18 2007 Paweł Gołaszewski <blues@pld-linux.org> 841018d
- rel.1 - put writable files in /var

* Sun Nov 18 2007 Paweł Gołaszewski <blues@pld-linux.org> 9f368ca
- outdated

* Sun Nov 18 2007 Paweł Gołaszewski <blues@pld-linux.org> e5eb4e4
- adjusted for 20.1 + new ones

* Sun Nov 18 2007 Paweł Gołaszewski <blues@pld-linux.org> cc87d8c
- 20.1 - mostly rewritten, with patches and resources from MDK

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> 0c54837
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 143745c
- converted to UTF-8

* Sun Dec 24 2006 Jakub Bogusz <qboosh@pld-linux.org> d1282a4
- updated Source0 URL (but only zips there)

* Tue Nov 07 2006 Elan Ruusamäe <glen@pld-linux.org> cae2c2a
- do not list %{_desktopdir}/* -- dangerous, could list directories unexpectedly

* Fri Apr 21 2006 Jan Rękorajski <baggins@pld-linux.org> 5e6ce89
- orphaned, outdated

* Tue Feb 28 2006 Elan Ruusamäe <glen@pld-linux.org> 0ced2ef
- adapterized (killed trailing spaces/tabs)

* Sat Jan 21 2006 Arkadiusz Miśkiewicz <arekm@maven.pl> 8ffc287
- kill Icon: field (support for these is obsolete says jbj)

